searchNodes=[{"doc":"Tabletop contains functions for playing a board game and querying the state of the game. Taking Turns Taking a turn involves calling the take_turn/2 function which follows these steps: Apply provided actions - e.g. add a piece, move a piece Apply board effects - e.g. check if a player has won Increment the turn counter To find out more about actions or effects, check the Tabletop.Actions or Tabletop.Board modules respectively.","ref":"Tabletop.html","title":"Tabletop","type":"module"},{"doc":"Returns the piece on the board at position . Examples iex&gt; Tabletop.Board . square ( 3 ) iex&gt; |&gt; Tabletop.Actions . apply ( :add , { Tabletop.Piece . new ( &quot;Rook&quot; ) , { 0 , 0 } } ) iex&gt; |&gt; Tabletop . get_piece ( { 0 , 0 } ) % Tabletop.Piece { id : &quot;Rook&quot; } iex&gt; Tabletop.Board . square ( 3 ) iex&gt; |&gt; Tabletop . get_piece ( { 1 , 0 } ) nil","ref":"Tabletop.html#get_piece/2","title":"Tabletop.get_piece/2","type":"function"},{"doc":"Checks if the provided position is within the bounds of the board . Examples iex&gt; Tabletop.Board . square ( 3 ) iex&gt; |&gt; Tabletop . in_bounds? ( { 0 , 0 } ) true iex&gt; Tabletop.Board . square ( 3 ) iex&gt; |&gt; Tabletop . in_bounds? ( { 99 , 99 } ) false","ref":"Tabletop.html#in_bounds?/2","title":"Tabletop.in_bounds?/2","type":"function"},{"doc":"Lazily moves through positions on the board starting from starting_position and returns sets of neighbouring positions. Each element will be a tuple containing two positions. Invokes fun with the current position in order to determine the positions of neighbours. Once every set of neighbouring positions are covered, no more elements will be returned. Examples iex&gt; Tabletop.Board.square(3) iex&gt; |&gt; Tabletop.neighbours({0, 0}, &amp;Tabletop.Grid.cardinal_points/1) iex&gt; |&gt; Enum.take(2) [{{0, 0}, {1, 0}}, {{0, 0}, {0, 1}}]","ref":"Tabletop.html#neighbours/3","title":"Tabletop.neighbours/3","type":"function"},{"doc":"Checks if the provided position on the board is occupied by a piece. Examples iex&gt; Tabletop.Board . square ( 3 ) iex&gt; |&gt; Tabletop.Actions . apply ( :add , { Tabletop.Piece . new ( &quot;Rook&quot; ) , { 0 , 0 } } ) iex&gt; |&gt; Tabletop . occupied? ( { 0 , 0 } ) true","ref":"Tabletop.html#occupied?/2","title":"Tabletop.occupied?/2","type":"function"},{"doc":"Applies the provided actions to the board and then advances to the next turn. Actions consist of a combination of the following: :move =&gt; {from, to} :add =&gt; {piece, position} :remove =&gt; position :assign =&gt; {position, attributes} For example, a Chess turn might see a single :move action or two :move actions in the case of castling. Examples iex&gt; % Tabletop.Board { } iex&gt; |&gt; Tabletop . take_turn ( %{ } ) % Tabletop.Board { turn : 2 } iex&gt; Tabletop.Board . square ( 3 ) iex&gt; |&gt; Tabletop . take_turn ( add : { Tabletop.Piece . new ( &quot;Rook&quot; ) , { 0 , 0 } } ) iex&gt; |&gt; Tabletop . take_turn ( move : { { 0 , 0 } , { 0 , 1 } } ) iex&gt; |&gt; Tabletop . get_piece ( { 0 , 1 } ) % Tabletop.Piece { id : &quot;Rook&quot; }","ref":"Tabletop.html#take_turn/2","title":"Tabletop.take_turn/2","type":"function"},{"doc":"Lazily moves through positions on the board starting from starting_position . Each element returned be a Tuple containing the position and piece at that position. Invokes fun with the current position in order to determine the next position. If the position does not contain a piece, the second element of the returned Tuple will be nil instead. Once the position is out of bounds, no more elements will be returned. Examples iex&gt; Tabletop.Board.square(3) iex&gt; |&gt; Tabletop.travel({0, 0}, fn {x, y} -&gt; {x + 1, y + 1} end) iex&gt; |&gt; Enum.to_list() [{{0, 0}, nil}, {{1, 1}, nil}, {{2, 2}, nil}]","ref":"Tabletop.html#travel/3","title":"Tabletop.travel/3","type":"function"},{"doc":"This module provides the fundamental actions involved in any tabletop game. Each action consists of a key and then an arguments value: :move =&gt; {from, to} :add =&gt; {piece, position} :remove =&gt; position :assign =&gt; {position, attributes} A game will take a combination of these actions which will then form a turn. For more information see the Tabletop.take_turn/2 function.","ref":"Tabletop.Actions.html","title":"Tabletop.Actions","type":"module"},{"doc":"Applies a particular action to the board . The type of action is determined by the atom provided with arg2 . This will then be mapped to a specific behaviour such as Moving or Adding a piece. If the type of action has not been implemented then the board will be returned with no changes made. Moving a Piece arg2 =&gt; :move arguments =&gt; {from, to} Moves the piece at the from position to the to position. Any existing pieces at the to position will be removed from the board and replaced by the moving piece. In the case that there is no piece to move, nothing will happen and the unchanged board struct will be returned. Adding a Piece arg2 =&gt; :add arguments =&gt; {%Tabletop.Piece{}, position} Adds the provided piece to the position on the board . Existing pieces will be removed from the board and replaced. If the position is not within the bounds of the board , the unchanged board will be returned. Removing a Piece arg2 =&gt; :remove arguments =&gt; position Removes the piece at the provided position if it is occupied. Does nothing to the board if the position does not contain a piece. Assigning Attributes to a Piece arg2 =&gt; :assign arguments =&gt; %{} Assigns the provided attributes to the piece at the provided position . If it does not exist then the unchanged board will be returned.","ref":"Tabletop.Actions.html#apply/3","title":"Tabletop.Actions.apply/3","type":"function"},{"doc":"This module provides the struct for representing the board of a tabletop game as well as the functions for creating and manipulating it. The Tabletop.Board Struct The public fields are: pieces - A map comprised of position keys and piece values, empty positions contain nil values attributes - A map of attributes held by the board turn - A number that represents the current turn effects - A list of functions that are applied at the end of each turn Effects At the end of each turn, the board will invoke each of its' effects in turn. Each effect should accept the board as input and return a board as output. This allows a game to perform updates before the end of each turn like spawning some zombies or determining if the game is over.","ref":"Tabletop.Board.html","title":"Tabletop.Board","type":"module"},{"doc":"Adds the provided effects to the board . Each effect should be a function that accepts a board and then returns a board. A single effect may also be provided.","ref":"Tabletop.Board.html#add_effects/2","title":"Tabletop.Board.add_effects/2","type":"function"},{"doc":"Increments the turn count of the board by 1.","ref":"Tabletop.Board.html#advance_turn/1","title":"Tabletop.Board.advance_turn/1","type":"function"},{"doc":"Applies the list of actions to the board in order and then returns the resulting board.","ref":"Tabletop.Board.html#apply_actions/2","title":"Tabletop.Board.apply_actions/2","type":"function"},{"doc":"Invokes each of the board's effects in order and then returns the affected board.","ref":"Tabletop.Board.html#apply_effects/1","title":"Tabletop.Board.apply_effects/1","type":"function"},{"doc":"Assigns the provided attributes to the board . Any existing attributes that share a key will be overriden.","ref":"Tabletop.Board.html#assign/2","title":"Tabletop.Board.assign/2","type":"function"},{"doc":"Gets the value of the attribute named attribute_name . Raises a KeyError if it doesn't exist.","ref":"Tabletop.Board.html#get/2","title":"Tabletop.Board.get/2","type":"function"},{"doc":"Creates a %Tabletop.Board with empty positions forming a square grid. Each position is a tuple containing x and y coordinates.","ref":"Tabletop.Board.html#square/1","title":"Tabletop.Board.square/1","type":"function"},{"doc":"This module provides functions specific to traversing a square board where positions are represented by 2D coordinate Tuples.","ref":"Tabletop.Grid.html","title":"Tabletop.Grid","type":"module"},{"doc":"Adds two coordinates together and returns the sum.","ref":"Tabletop.Grid.html#add/2","title":"Tabletop.Grid.add/2","type":"function"},{"doc":"Returns a list of neighbours from the given position, 1 unit in each cardinal direction.","ref":"Tabletop.Grid.html#cardinal_points/1","title":"Tabletop.Grid.cardinal_points/1","type":"function"},{"doc":"This module provides the struct for representing pieces on the board as well as functions to manipulate them. The Tabletop.Piece Struct The public fields are: id - An identifier used for display or querying attributes - A map of attributes held by the piece","ref":"Tabletop.Piece.html","title":"Tabletop.Piece","type":"module"},{"doc":"Assigns the provided attributes to the piece . Any existing attributes that share a key will be overridden.","ref":"Tabletop.Piece.html#assign/2","title":"Tabletop.Piece.assign/2","type":"function"},{"doc":"Checks if two pieces are the same by comparing ids.","ref":"Tabletop.Piece.html#equal?/2","title":"Tabletop.Piece.equal?/2","type":"function"},{"doc":"Creates a new piece with the given id .","ref":"Tabletop.Piece.html#new/1","title":"Tabletop.Piece.new/1","type":"function"}]